SystemOrganization addCategory: #TGListModel!

TestCase subclass: #TGListModelTest
	instanceVariableNames: 'lm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:42'!
testDeleteSelection

	lm := TGListModel new.
	lm list: {1. 2. 3}.
	lm selectionIndex: 3.
	lm deleteSelection.
	self assert: {1. 2} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm deleteSelection.	
	self assert: {1} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm deleteSelection.	
	self assert: {} equals: lm list.
	self assert: 0 equals: lm selectionIndex.
	"sanity test"
	lm insert: 100 at: 1.
	self assert: {100} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:49'!
testInsertAllAt

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm insertAll: {6. 7. 8. 9} at: 4.
	self assert: {1. 2. 3. 4. 6. 7. 8. 9. 5} equals: lm list.
	self assert: 8 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:35'!
testInsertAt

	lm := TGListModel new.
	lm insert: 'hi' at: 1.
	self assert: {'hi'} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm insert: 'there' at: 1.
	self assert: {'hi'. 'there'} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm insert: 'you' at: 1.
	self assert: {'hi'. 'you'. 'there'} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm insert: 'lala' at: 3.
	self assert: {'hi'. 'you'. 'there'. 'lala'} equals: lm list.
	self assert: 4 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:31'!
testInsertInsaneIndex

	lm := TGListModel new.
	lm insert: 'hi' at: 29.
	self assert: {'hi'} equals: lm list.
	self assert: 1 equals: lm selectionIndex.! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:38'!
testMoveSelectionDown

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm moveSelectionDown.	
	self assert: {1. 2. 4. 3. 5} equals: lm list.
	self assert: 4 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {1. 2. 4. 5. 3} equals: lm list.
	self assert: 5 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {1. 2. 4. 5. 3} equals: lm list.
	self assert: 5 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:37'!
testMoveSelectionUp

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm moveSelectionUp.	
	self assert: {1. 3. 2. 4. 5} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm moveSelectionUp.
	self assert: {3. 1. 2. 4. 5} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm moveSelectionUp.
	self assert: {3. 1. 2. 4. 5} equals: lm list.
	self assert: 1 equals: lm selectionIndex.! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:40'!
testMoveSelectionUpDownWithOneItem

	lm := TGListModel new.
	lm list: {3}.
	lm selectionIndex: 1.
	lm moveSelectionUp.
	self assert: {3} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {3} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
! !

Object subclass: #TGListModel
	instanceVariableNames: 'list selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModel methodsFor: 'jumping' stamp: 'hjo 4/14/2012 20:36'!
atEnd
	^ self list size = self selectionIndex! !

!TGListModel methodsFor: 'as yet unclassified' stamp: 'hjo 4/29/2012 22:43'!
deleteSelection

	list isEmpty ifTrue: [^self].
	list := (list copyFrom: 1 to: selectionIndex-1), (list copyFrom: selectionIndex+1 to: list size).
	selectionIndex > list size ifTrue: [selectionIndex := list size].! !

!TGListModel methodsFor: 'initialization' stamp: 'hjo 4/14/2012 18:29'!
initialize

	super initialize.
	list := Array new.
	selectionIndex := 0.! !

!TGListModel methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:43'!
insert: anObject at: anInteger

	(anInteger between: 1 and: list size)
		ifTrue: [ list := (list copyFrom: 1 to: anInteger), (Array with: anObject), (list copyFrom:anInteger+1 to: list size).
			selectionIndex := anInteger+1]
		ifFalse: [list := Array with: anObject.
			selectionIndex := 1 ].! !

!TGListModel methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 19:52'!
insertAll: anArray at: anInteger

	list := Array streamContents: [:stream| 
		stream nextPutAll: (list copyFrom: 1 to: anInteger).
		stream nextPutAll: anArray.
		stream nextPutAll: (list copyFrom: anInteger+1 to: list size).
		].
	selectionIndex := anInteger + anArray size.

	! !

!TGListModel methodsFor: 'accessing' stamp: 'hjo 4/14/2012 18:20'!
list
	^ list! !

!TGListModel methodsFor: 'accessing' stamp: 'hjo 4/14/2012 18:20'!
list: anOrderedCollection
	list := anOrderedCollection
! !

!TGListModel methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:39'!
moveSelectionDown

	selectionIndex = list size ifTrue: [^self].
	list swap: selectionIndex with: selectionIndex+1.
	selectionIndex := selectionIndex + 1.! !

!TGListModel methodsFor: 'as yet unclassified' stamp: 'hjo 4/14/2012 18:36'!
moveSelectionUp

	selectionIndex = 1 ifTrue: [^self].
	list swap: selectionIndex-1 with: selectionIndex.
	selectionIndex := selectionIndex-1.! !

!TGListModel methodsFor: 'annotation text' stamp: 'hjo 4/14/2012 20:33'!
selection
	^ self list at: self selectionIndex! !

!TGListModel methodsFor: 'accessing' stamp: 'hjo 4/14/2012 18:20'!
selectionIndex
	^ selectionIndex! !

!TGListModel methodsFor: 'accessing' stamp: 'hjo 4/14/2012 18:20'!
selectionIndex: anInteger
	selectionIndex := anInteger
! !
